/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ReportRawData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ReportRawData{}

// ReportRawData struct for ReportRawData
type ReportRawData struct {
	Results []ReportRawDataEntry `json:"results"`
}

// NewReportRawData instantiates a new ReportRawData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportRawData(results []ReportRawDataEntry) *ReportRawData {
	this := ReportRawData{}
	this.Results = results
	return &this
}

// NewReportRawDataWithDefaults instantiates a new ReportRawData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportRawDataWithDefaults() *ReportRawData {
	this := ReportRawData{}
	return &this
}

// GetResults returns the Results field value
func (o *ReportRawData) GetResults() []ReportRawDataEntry {
	if o == nil {
		var ret []ReportRawDataEntry
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *ReportRawData) GetResultsOk() ([]ReportRawDataEntry, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *ReportRawData) SetResults(v []ReportRawDataEntry) {
	o.Results = v
}

func (o ReportRawData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ReportRawData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	return toSerialize, nil
}

type NullableReportRawData struct {
	value *ReportRawData
	isSet bool
}

func (v NullableReportRawData) Get() *ReportRawData {
	return v.value
}

func (v *NullableReportRawData) Set(val *ReportRawData) {
	v.value = val
	v.isSet = true
}

func (v NullableReportRawData) IsSet() bool {
	return v.isSet
}

func (v *NullableReportRawData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportRawData(val *ReportRawData) *NullableReportRawData {
	return &NullableReportRawData{value: val, isSet: true}
}

func (v NullableReportRawData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportRawData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


